<script context="module">
  import { Api, ApiError } from "../../../api.js"
  import * as model from "../../../model.js"

  export async function preload(page, { config }) {
    const { bopiId } = page.params
    const api = new Api(config, { fetch: this.fetch })

    let bopi
    try {
      bopi = await api.bopiShow(bopiId)
    } catch (error) {
      if (error instanceof ApiError) {
        return this.error(500, error)
      }
      throw error
    }

    if (bopi.archived) {
      return this.error(409, "Un BOPI archivé ne peut pas être publié")
    }

    if (model.isGenerationInProgress(bopi.tasks.latest)) {
      return this.error(409, "Ce BOPI est déjà en cours de publication")
    }

    return { bopi }
  }
</script>

<script>
  export let bopi

  import { goto, stores } from "@sapper/app"
  import Card from "sveltestrap/src/Card.svelte"
  import CardBody from "sveltestrap/src/CardBody.svelte"
  import CardFooter from "sveltestrap/src/CardFooter.svelte"
  import CardHeader from "sveltestrap/src/CardHeader.svelte"
  import CardSubtitle from "sveltestrap/src/CardSubtitle.svelte"
  import Spinner from "sveltestrap/src/Spinner.svelte"
  import BopiInfos from "../../../components/BopiInfos.svelte"
  import ButtonIcon from "../../../components/ButtonIcon.svelte"
  import FilesTable from "../../../components/FilesTable.svelte"

  const { session } = stores()
  const { config } = $session
  const { allSectionsCode, sectionList } = config

  let withColor = true
  let checkedSections = [...sectionList]
  let generatePdfResponse

  const api = new Api(config)

  function handleGenerate() {
    const body = {
      color: withColor,
      sections:
        checkedSections.length == sectionList.length
          ? [allSectionsCode]
          : checkedSections
    }
    generatePdfResponse = api.bopiRun(bopi.id, body).then(() => {
      goto(`./bopi/${bopi.id}`)
    })
  }
</script>

<svelte:head>
  <title>bopyweb | Publication du BOPI n°{bopi.id}</title>
</svelte:head>

<h1 class="page-title">Publication du BOPI n°{bopi.id}</h1>

<div class="my-5">
  <ButtonIcon icon="bx-arrow-back" href={`./bopi/${bopi.id}`}>
    Retour au BOPI
  </ButtonIcon>
</div>

<div class="my-5">
  <BopiInfos {bopi} />
</div>

<div class="my-5">
  <FilesTable {bopi} />
</div>

<form on:submit|preventDefault={handleGenerate}>
  <Card class="my-5">
    <CardHeader>Génération du document PDF</CardHeader>
    <CardBody>
      <div class="mb-4">
        <label for="color_input">
          <input id="color_input" type="checkbox" bind:checked={withColor} />
          avec couleur
        </label>
      </div>
      <div class="mt-4">
        <CardSubtitle>
          <h6>Sections à générer</h6>
        </CardSubtitle>
        <div style="clear: both;">
          {#each sectionList as section}
            <div style="display: inline-block; width: 10em;">
              <label>
                <input
                  type="checkbox"
                  bind:group={checkedSections}
                  value={section} />
                {section}
              </label>
            </div>
          {/each}
        </div>
      </div>
    </CardBody>
    <CardFooter>
      {#if generatePdfResponse}
        {#await generatePdfResponse}
          <!-- promise is pending -->
          <ButtonIcon icon="bx-book" color="primary" disabled type="submit">
            Générer le PDF
            <Spinner />
          </ButtonIcon>
        {:then value}
          <!-- promise was fulfilled -->
        {:catch error}
          <ButtonIcon icon="bx-book" color="primary" type="submit">
            Générer le PDF
          </ButtonIcon>
          <!-- promise was rejected -->
          <p class="text-danger">
            Impossible de lancer la génération du PDF.
            {#if error instanceof ApiError}{error.message}{/if}
          </p>
        {/await}
      {:else}
        <ButtonIcon icon="bx-book" color="primary" type="submit">
          Générer le PDF
        </ButtonIcon>
      {/if}
    </CardFooter>
  </Card>
</form>
